// Fill out your copyright notice in the Description page of Project Settings.


#include "BountyHunterCharacter.h"

#include "EndlessVendetta/EVGameInstance.h"
#include "Kismet/GameplayStatics.h"

void ABountyHunterCharacter::SpawnBounties()
{
	UE_LOG(LogTemp, Warning, TEXT("Spawning Bounty..."));

	UEVGameInstance* GI = Cast<UEVGameInstance>(GetGameInstance());

	if (!IsValid(GI->MainSaveGameInstanceRef))
	{
		UE_LOG(LogTemp, Warning, TEXT("Main save Game Object isnt initialized in GI"));
		return;
	}
	
	int TestNum = GI->MainSaveGameInstanceRef->CurrentMainBountyIndexSave;
	UE_LOG(LogTemp, Warning, TEXT("Current Index is set to....%d"), TestNum);

	GI->MainSaveGameInstanceRef->CurrentMainBountyIndexSave = 40;

	UGameplayStatics::SaveGameToSlot(GI->MainSaveGameInstanceRef, "MainSave", 0);
	
	if (MainBountyClasses.IsEmpty() || !IsValid(MainBountyClasses[CurrentMainBountyIndex])) return;

	CurrentMainBounty = GetWorld()->SpawnActor<AMainBountyClass>(MainBountyClasses[CurrentMainBountyIndex]);
	const FAttachmentTransformRules AttachmentTransformRules(EAttachmentRule::SnapToTarget, true);
	AttachToComponent(GetRootComponent(), AttachmentTransformRules);

	UGameplayStatics::GetCurrentLevelName(GetWorld()) == OpenWorldLevelName ? CurrentMainBounty->SpawnOpenWorldCheckpoint() : CurrentMainBounty->SpawnCheckpoints();
}

void ABountyHunterCharacter::CompleteCurrentMainBounty()
{
	UE_LOG(LogTemp, Warning, TEXT("Would be collecting reward for completing bounty and moving onto next if possible"));
}

void ABountyHunterCharacter::BeginPlay()
{
	if (UGameplayStatics::DoesSaveGameExist("MainSave", 0)) SpawnBounties();
	Super::BeginPlay();
}

void ABountyHunterCharacter::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
}

